100 REM Terry's Tesla Coil Program
GOSUB 21000
GOTO 5000


1000 CLS
COLOR 14, 0, 0
PRINT " Charging Circuit Input:"
COLOR 7, 0, 0
PRINT " 1 Transformer Output Voltage (RMS): "; TransOutVolt
PRINT " 2 Transformer Output Current (RMS): "; TransOutCurr
PRINT " 3 Primary Capacitor Value (uF): "; Cpri * 1000000!;
CpriS = TransOutCurr / 3
COLOR 10, 0, 0: PRINT " <<="; CpriS: COLOR 7, 0, 0
PRINT " 4 Pimary Capacitor Firing Voltage (volts): "; Vpri;
COLOR 10, 0, 0: PRINT " <<="; TransOutVolt * 1.414: COLOR 7, 0, 0
PRINT " 5 Break Rate (BPS): "; bps
PRINT

COLOR 14, 0, 0
PRINT " Charging Circuit Output:"
COLOR 11, 0, 0
PRINT " Primary Capacitor Firing Voltage (volts):"; Vpri
PRINT " Primary Energy per Bang (J):"; PriEn
PRINT " Primary Power (W): "; PriPow
PRINT : PRINT

COLOR 14, 0, 0
PRINT " Primary Circuit Input:"
COLOR 7, 0, 0
PRINT " 6 Primary Inner Diameter (in): "; PriIDia
PRINT " 7 Primary Turns: "; PriTurns;
COLOR 10, 0, 0: PRINT " <<="; PriTurnsS: COLOR 7, 0, 0
PRINT " 8 Primary Winding Pitch (in): "; PriPitch
PRINT " 9 Primary Cap Value (uf): "; Cpri * 1000000!
PRINT

COLOR 14, 0, 0
PRINT " Primary Circuit Output:"
COLOR 11, 0, 0
PRINT " Primary Fundamental Frequency: "; FoPri
PRINT " Primary Inductance (uH): "; Lpri * 1000000!
PRINT " Primary Capacitance (uF): "; Cpri * 1000000!
PRINT " Primary Current (RMS): "; Ipri
PRINT " Primary Reactance (Ohm): "; Rpri
PRINT " Primary Voltage (RMS): "; Vpri / 1.414
PRINT : PRINT

COLOR 14, 0, 0
PRINT " Secondary Circuit Input:"
COLOR 7, 0, 0
PRINT " 10 Secondary Diameter (in): "; SecDia
PRINT " 11 Secondary Length (in): "; SecLen
PRINT " 12 Secondary Turns: "; SecTurns
PRINT " 13 Secondary Top Capacitance (pF): "; Ctop * 1E+12
PRINT

COLOR 14, 0, 0
PRINT " Secondary Circuit Output:"
COLOR 11, 0, 0
PRINT " Secondary Fundamental Frequency: "; FoSec
PRINT " Secondary Inductanc (mH): "; Lsec * 1000
PRINT " Secondary Self Capacitance (pF): "; Cself * 1E+12
PRINT " Secondary Total Capacitance (pF): "; Csec * 1E+12
PRINT " Secondary Output Voltage (Peak): "; Vsec
PRINT " Secondary Reactance (Ohm): "; Rsec
PRINT " Secondary Current (RMS): "; Isec
PRINT : PRINT
COLOR 12, 0, 0

q1 = 0
1010 INPUT " Input parameter, Print, End"; q$
q1 = VAL(q$)
IF q$ = "i" OR q$ = "I" THEN INPUT " Parameter Number "; q1
IF q$ = "p" OR q$ = "P" THEN GOSUB 22000
IF q$ = "e" OR q$ = "E" THEN GOSUB 20000: GOTO 10000
ON q1 GOTO 2100, 2200, 2300, 2400, 2450, 2500, 2600, 2700, 2300, 2900, 3000, 3100, 3200
GOTO 1000

2100 REM TransOutVolt
INPUT " What is the rated output voltage of the transformer in volts RMS "; TransOutVolt
GOTO 5000

2200 REM TransOutCurr
INPUT " What is the rated output current of the transformer in amps RMS "; TransOutCurr
GOTO 5000


2300 REM Cpri
INPUT " What is the primary capacitor value in uF "; Cpri
Cpri = Cpri / 1000000!
GOTO 5000

2400 REM Vpri
INPUT " What is the primary capacitor firing voltage in Volts "; Vpri
GOTO 5000

2450 REM Bps
INPUT " What is the firing rate per second "; bps
GOTO 5000


2500 REM PriIDia
INPUT " What is the inner primary coil diameter in inches "; PriIDia
GOTO 5000

2600 REM PriTurns
INPUT " How many turns are being used on the primary "; PriTurns
GOTO 5000

2700 REM PriPitch
INPUT " What is the turn to turn distance (pitch) of the primary "; PriPitch
GOTO 5000

2900 REM SecDia
INPUT " What is the secondary diameter in inches "; SecDia
GOTO 5000

3000 REM SecLen
INPUT " What is the secondary length in inches "; SecLen
GOTO 5000

3100 REM SecTurns
INPUT " How many secondary turns are there "; SecTurns
GOTO 5000

3200 REM CTop
INPUT " What is the top terminal added capacitance in pF "; Ctop
Ctop = Ctop / 1E+12

GOTO 5000

5000 REM Calculate the parameters

REM Vpri
Vpri = Vpri

REM PriEn
PriEn = .5 * Cpri * Vpri ^ 2


REM PriPow
PriPow = PriEn * bps


5100 REM Lpri
IF PriIDia = 0 OR PriTurns = 0 OR PriPitch = 0 THEN 5200
r = PriIDia / 2 + PriTurns * PriPitch / 2
w = PriTurns * PriPitch
Lpri = 1 / 1000000 * r ^ 2 * PriTurns ^ 2 / (8 * r + 11 * w)


REM FoPri
IF Lpri <> 0 AND Cpri <> 0 THEN FoPri = 1 / (2 * 3.14159 * SQR(Lpri * Cpri))

5200   REM


Rpri = 2 * 3.14159 * FoPri * Lpri


IF Rpri <> 0 THEN Ipri = Vpri / Rpri / 1.414


IF SecDia <> 0 AND SecLen <> 0 THEN Lsec = 1 / 1000000 * (SecDia / 2) ^ 2 * SecTurns ^ 2 / (9 * SecDia / 2 + 10 * SecLen)


IF SecDia <> 0 THEN Cself = 1E-12 * (.1 * SecLen / SecDia + .31) * 2.54 * SecDia


IF Cself <> 0 AND Ctop <> 0 THEN Csec = Cself + Ctop


IF Lsec <> 0 AND Csec <> 0 THEN FoSec = 1 / (2 * 3.14159 * SQR(Lsec * Csec))


IF Csec <> 0 THEN Vsec = Vpri * SQR(Cpri / Csec)


Rsec = 2 * 3.14159 * FoSec * Lsec


IF Rsec <> 0 THEN Isec = Vsec / Rsec / 1.414

REM find PriTurnsS
IF Cpri = 0 THEN 1000
L1 = Lsec * Csec / Cpri
FOR x = 1 TO 50 STEP .01
rad = PriIDia / 2 + x * PriPitch / 2
w = x * PriPitch
L2 = .000001 * rad * rad * x * x / (8 * rad + 11 * w)

IF L2 > L1 THEN PriTurnsS = x: GOTO 1000
NEXT x
    

GOTO 1000


10000 REM END
COLOR 7, 0, 0

END


20000 REM Save The Data
OPEN "save.dat" FOR OUTPUT AS #1
PRINT #1, TransOutVolt
PRINT #1, TransOutCurr
PRINT #1, Cpri
PRINT #1, bps
PRINT #1, Vpri
PRINT #1, PriIDia
PRINT #1, PriTurns
PRINT #1, PriPitch
PRINT #1, SecDia
PRINT #1, SecLen
PRINT #1, SecTurns
PRINT #1, Ctop

CLOSE #1
20100 RETURN

21000 REM Get The Data
OPEN "save.dat" FOR INPUT AS #1
INPUT #1, TransOutVolt
INPUT #1, TransOutCurr
INPUT #1, Cpri
INPUT #1, bps
INPUT #1, Vpri
INPUT #1, PriIDia
INPUT #1, PriTurns
INPUT #1, PriPitch
INPUT #1, SecDia
INPUT #1, SecLen
INPUT #1, SecTurns
INPUT #1, Ctop

CLOSE #1
21100 RETURN


22000 REM Print

LPRINT "Terry's Tesla Coil Analysis Program"
LPRINT DATE$; "    "; TIME$
                        
LPRINT : LPRINT
LPRINT " Charging Circuit Input:"

LPRINT " Transformer Output Voltage (RMS): "; TransOutVolt
LPRINT " Transformer Output Current (RMS): "; TransOutCurr
LPRINT " Primary Capacitor Value (uF): "; Cpri * 1000000!;
CpriS = TransOutCurr / 3
LPRINT " <<="; CpriS
LPRINT " Pimary Capacitor Firing Voltage (volts): "; Vpri;
LPRINT " <<="; TransOutVolt * 1.414
LPRINT " Break Rate (BPS): "; bps: bps = 120
LPRINT


LPRINT " Charging Circuit Output:"

LPRINT " Primary Capacitor Firing Voltage (volts):"; Vpri
LPRINT " Primary Energy per Bang (J):"; PriEn
LPRINT " Primary Power (W): "; PriPow
LPRINT : PRINT


LPRINT " Primary Circuit Input:"
LPRINT " Primary Inner Diameter (in): "; PriIDia
LPRINT " Primary Turns: "; PriTurns;
LPRINT " <<="; PriTurnsS
LPRINT " Primary Winding Pitch (in): "; PriPitch
LPRINT " Primary Cap Value (uf): "; Cpri * 1000000!
LPRINT


LPRINT " Primary Circuit Output:"

LPRINT " Primary Fundamental Frequency: "; FoPri
LPRINT " Primary Inductance (uH): "; Lpri * 1000000!
LPRINT " Primary Capacitance (uF): "; Cpri * 1000000!
LPRINT " Primary Current (RMS): "; Ipri
LPRINT " Primary Reactance (Ohm): "; Rpri
LPRINT " Primary Voltage (RMS): "; Vpri / 1.414

LPRINT : PRINT


LPRINT " Secondary Circuit Input:"

LPRINT " Secondary Diameter (in): "; SecDia
LPRINT " Secondary Length (in): "; SecLen
LPRINT " Secondary Turns: "; SecTurns
LPRINT " Secondary Top Capacitance (pF): "; Ctop * 1E+12
LPRINT


LPRINT " Secondary Circuit Output:"

LPRINT " Secondary Fundamental Frequency: "; FoSec
LPRINT " Secondary Inductanc (mH): "; Lsec * 1000
LPRINT " Secondary Self Capacitance (pF): "; Cself * 1E+12
LPRINT " Secondary Total Capacitance (pF): "; Csec * 1E+12
LPRINT " Secondary Output Voltage (Peak): "; Vsec
LPRINT " Secondary Reactance (Ohm): "; Rsec
LPRINT " Secondary Current (RMS): "; Isec
LPRINT : LPRINT : LPRINT CHR$(12);

RETURN


